<?php
// wcf imports
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');
require_once(WCF_DIR.'lib/data/rule/RulesetEditor.class.php');

/**
 * User Agreements delete action.
 *
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	acp.action
 * @category 	Community Framework (commercial)
 */
class RuleDeleteAgreementsAction extends AbstractAction {
	/**
	 * Ruleset ID
	 *
	 * @var	integer
	 */
	public $rulesetID = 0;
	
	/**
	 * Location
	 *
	 * @var	integer
	 */
	public $from = 'ruleitemlist';
	
	/**
	 * @see	Action::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();
		
		if (isset($_REQUEST['rulesetID'])) $this->rulesetID = intval($_REQUEST['rulesetID']);
		if (isset($_REQUEST['from'])) $this->from = StringUtil::toLowerCase($_REQUEST['from']);
	}
	
	/**
	 * @see Action::execute()
	 */
	public function execute() {
		parent::execute();
		
		// check userpermission
		WCF::getUser()->checkPermission(array('admin.rule.canEditItem', 'admin.rule.ruleset.canEdit'));
		
		// if no special ruleset is given, we select the active ruleset of the package.
		if ($this->rulesetID == 0) {
			$ruleset = Ruleset::getActiveRuleset(PACKAGE_ID);
		}
		else {
			$ruleset = new Ruleset($this->rulesetID);
		}
		
		//if no ruleset exists, we have a fail and throw a exception
		if (!$ruleset->rulesetID) {
			throw new IllegalLinkException();
		}
		
		$rulesetEditor = $ruleset->getEditor();
		$rulesetEditor->deleteUserAgreements();
		
		// special call from executed method.
		$this->executed();
		
		switch ($this->from) {
			case 'ruleitemlist':
				HeaderUtil::redirect('index.php?page=RuleItemList&deletedAgreements=1&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
				break;
			case 'ruleset':
				HeaderUtil::redirect('index.php?form=Ruleset&deletedAgreements=1&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
				break;
		}
	}
}
?>