<?php
// wcf imports
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');
require_once(WCF_DIR.'lib/data/rule/RuleItemEditor.class.php');
require_once(WCF_DIR.'lib/data/rule/Ruleset.class.php');

/**
 * Rule item delete action.
 *
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	acp.action
 * @category 	Community Framework (commercial)
 */
class RuleItemDeleteAction extends AbstractAction {
	/**
	 * rule item id
	 *
	 * @var integer
	 */
	public $ruleItemID = 0;

	/**
	 * rule item object
	 *
	 * @var RuleItemEditor
	 */
	public $ruleItem = null;

	/**
	 * @see Action::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();

		if (isset($_REQUEST['ruleItemID'])) $this->ruleItemID = intval($_REQUEST['ruleItemID']);
		$this->ruleItem = new ruleItemEditor($this->ruleItemID);
		if (!$this->ruleItem->ruleItemID) {
			throw new IllegalLinkException();
		}
		
		if (isset($_REQUEST['rulesetID'])) {
			$this->ruleset = new Ruleset(intval($_REQUEST['rulesetID']));
		}
		if ($this->ruleset === null || !$this->ruleset->rulesetID) {
				$this->ruleset = Ruleset::getActiveRuleset();
		}
	}

	/**
	 * @see Action::execute()
	 */
	public function execute() {
		parent::execute();

		// check permissions
		WCF::getUser()->checkPermission('admin.rule.canDeleteItem');

		// delete
		$this->ruleItem->delete();
		
		$this->executed();

		// forward to list page
		header('Location: index.php?page=RuleItemList&deletedRuleItemID='.$this->ruleItemID.'&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
		exit;
	}
}
?>