<?php
// wcf imports
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');
require_once(WCF_DIR.'lib/data/rule/RuleItemEditor.class.php');

/**
 * Renames a rule item.
 *
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	acp.action
 * @category 	Community Framework (commercial)
 */
class RuleItemRenameAction extends AbstractAction {
	/**
	 * Rule Item ID
	 *
	 * @var	integer
	 */
	public $ruleItemID = 0;
	
	/**
	 * title
	 *
	 * @var	string
	 */
	public $title = '';

	/**
	 * @see Action::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();

		if (isset($_REQUEST['ruleItemID'])) $this->ruleItemID = intval($_REQUEST['ruleItemID']);
		if (isset($_POST['title'])) {
			$this->title = $_POST['title'];
			if (CHARSET != 'UTF-8') $this->title = StringUtil::convertEncoding('UTF-8', CHARSET, $this->title);
		}
	}

	/**
	 * @see Action::execute()
	 */
	public function execute() {
		parent::execute();

		// check permission
		WCF::getUser()->checkPermission('admin.rule.canEditItem');

		// get rule item
		$ruleItem = new RuleItemEditor($this->ruleItemID);
		if (!$ruleItem->ruleItemID) {
			throw new IllegalLinkException();
		}

		// change language variable
		require_once(WCF_DIR.'lib/system/language/LanguageEditor.class.php');
		$language = new LanguageEditor(WCF::getLanguage()->getLanguageID());
		$language->updateItems(array('wcf.rules.item.' . $ruleItem->ruleItem => $this->title), 0, PACKAGE_ID, array('wcf.rules.item.' . $ruleItem->ruleItem => 1));

		$this->executed();
	}
}
?>