<?php
// wcf imports
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');
require_once(WCF_DIR.'lib/data/rule/RuleItemEditor.class.php');

/**
 * Sorts the structure of rule items.
 *
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	acp.action
 * @category 	Community Framework (commercial)
 */
class RuleItemSortAction extends AbstractAction {
	/**
	 * New positions
	 *
	 * @var	array<mixed>
	 */
	public $positions = array();
	
	/**
	 * Ruleset ID
	 *
	 * @var integer
	 */
	public $rulesetID = 0;

	/**
	 * @see Action::readParameters()
	 */
	public function readParameters() {
		parent::readParameters();

		// get positions
		if (isset($_POST['ruleListPositions']) && is_array($_POST['ruleListPositions'])) $this->positions = ArrayUtil::toIntegerArray($_POST['ruleListPositions']);
		if (isset($_POST['rulesetID'])) $this->rulesetID = intval($_POST['rulesetID']);
	}

	/**
	 * @see Action::execute()
	 */
	public function execute() {
		parent::execute();

		// check permissions
		WCF::getUser()->checkPermission('admin.rule.canEditItem');

		// update postions
		foreach ($this->positions as $ruleItemID => $data) {
			foreach ($data as $parentRuleItemID => $position) {
				$parentRuleItem = '';
				if ($parentRuleItemID != 0) {
					$parentRuleObject = new RuleItem($parentRuleItemID);
					$parentRuleItem = $parentRuleObject->ruleItem;
				}

				RuleItemEditor::updateShowOrder(intval($ruleItemID), $parentRuleItem, $position);
			}
		}

		$this->executed();

		// forward to list page
		HeaderUtil::redirect('index.php?page=RuleItemList&rulesetID='.$this->rulesetID.'&successfullSorting=1&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
		exit;
	}
}
?>