<?php
// wcf imports
require_once(WCF_DIR.'lib/action/AbstractAction.class.php');
require_once(WCF_DIR.'lib/data/rule/RulesetEditor.class.php');

/**
 * Rule set delete action.
 * 
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	acp.action
 * @category 	Community Framework (commercial)
 */
class RulesetDeleteAction extends AbstractAction {
	/**
	 * Ruleset
	 *
	 * @var Ruleset
	 */
	public $ruleset = null;
	
	/**
	 * Ruleset ID
	 *
	 * @var	integer
	 */
	public $rulesetID = 0;
	
	/**
	 * @see Action::readParameter()
	 */
	public function readParameters() {
		parent::readParameters();
		
		// check permission
		WCF::getUser()->checkPermission('admin.rule.ruleset.canEdit');
		
		if (isset($_REQUEST['rulesetID'])) $this->rulesetID = intval($_REQUEST['rulesetID']);
		$this->ruleset = new RulesetEditor($this->rulesetID);
		
		if (!$this->ruleset->rulesetID) {
			throw new IllegalLinkException();
		}
	}
	
	/**
	 * @see Action::execute()
	 *
	 */
	public function execute() {
		parent::execute();
		
		$this->ruleset->delete();
		parent::executed();
		HeaderUtil::redirect('index.php?form=Ruleset&packageID='.PACKAGE_ID.SID_ARG_2ND_NOT_ENCODED);
	}
}
?>