<?php
//wcf imports
require_once(WCF_DIR.'lib/page/AbstractPage.class.php');
require_once(WCF_DIR.'lib/data/rule/Ruleset.class.php');
require_once(WCF_DIR.'lib/page/util/menu/PageMenu.class.php');

/**
 * Show the term of use.
 *
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	page
 * @category 	Community Framework (commercial)
 */
class RulesPage extends AbstractPage {
	public $templateName = 'rulesShow';

	public $ruleset = null;
	public $ruleList = array();

	/**
	 * @see AbstractPage::readData();
	 */
	public function readData() {
		parent::readData();

		$this->ruleset = Ruleset::getActiveRuleset();
		$this->ruleList = $this->ruleset->getRuleList();

		PageMenu::setActiveMenuItem('wcf.header.menu.rules');
	}

	/**
	 * @see AbstractPage::assignVariables();
	 */
	public function assignVariables() {
		parent::assignVariables();
		
		WCF::getTPL()->assign(array(
			'ruleset' => $this->ruleset,
			'ruleList' => $this->ruleList
		));
	}
}
?>