<?php
//wcf imports
require_once(WCF_DIR.'lib/system/event/EventListener.class.php');
require_once(WCF_DIR.'lib/data/rule/Ruleset.class.php');

/**
 * Userregistration eventlistener for rules
 *
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	system.event.listener
 * @category 	Community Framework (commercial)
 */
class RulesRegisterListener implements EventListener {
	/**
	 * @see EventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		if (MODULE_RULE == 0) return;
		if ($className ==  'RegisterPage') {
			// show page
			if ($eventName == 'show') {
				//If the user do not check the checkbox.
				if (REGISTER_ENABLE_DISCLAIMER) {
					if ($eventObj->action == 'register') {
						$agree = WCF::getSession()->getVar('rulesAreAgree');
			
						if ($agree == null) {
							if (isset($_REQUEST['rulesAgree'])) $agree = intval($_REQUEST['rulesAgree']);
						}
						
						try {
							if ($agree != 1) {
								throw new UserInputException('rulesAgree');
							}
							else {
								WCF::getSession()->register('rulesAreAgree', 1);
							}
						}
						catch (UserInputException $e) {
							$errorField = $e->getField();
							WCF::getTPL()->assign('errorField', $errorField);
							require_once(WCF_DIR.'lib/page/RulesRegisterPage.class.php');
							new RulesRegisterPage();
							exit;
						}
					}
				}	
				//Overwrite the last lines of the RegisterPage Class.
				switch ($eventObj->action) {
					case '':
						if (REGISTER_ENABLE_DISCLAIMER) {
							require_once(WCF_DIR.'lib/page/RulesRegisterPage.class.php');
							new RulesRegisterPage();
							break;
						}
					default:
						require_once(WCF_DIR.'lib/form/RegisterForm.class.php');
						new RegisterForm();
				}
				exit;
			}
		}
		//if the user agree the rules.
		if ($className == 'RegisterForm') {
			if ($eventName == 'saved') {
				$ruleset = Ruleset::getActiveRuleset(PACKAGE_ID);
				$ruleset->makeUserAgree($eventObj->user->userID);
			}
		}
	}
}
?>