<?php
// wcf imports
require_once(WCF_DIR.'lib/system/event/EventListener.class.php');
require_once(WCF_DIR.'lib/data/rule/Ruleset.class.php');

/**
 * Eventlistener for rules, if the user must agree the rules after the rules changed
 *
 * @author 	Karsten Achterrath
 * @copyright	2001-2009 WoltLab GmbH
 * @license	WoltLab Burning Board License <http://www.woltlab.com/products/burning_board/license.php>
 * @package	com.woltlab.wcf.termsOfUse
 * @subpackage	system.event.listener
 * @category 	Community Framework (commercial)
 */
class RulesUserListener implements EventListener {
	protected static $ignoreForms = array(
		'rulesagree',
		'userprofileedit',
		'accountmanagement',
	);
	protected static $ignorePages = array(
		'legalnotice'
	);
	
	/**
	 * @see EventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		$session = $eventObj->session;
		
		// if the modul deactivatet, or the user must no agree the rules, we can leave the event.
		// if we log out or on the rulesagree page, we also leave the event.
		if (MODULE_RULE == 0 || $session->getUser()->getPermission('admin.general.canIgnoreRules')) return;
		if ((isset($_REQUEST['action']) && strtolower($_REQUEST['action']) == 'userlogout') || (isset($_REQUEST['form']) && in_array(strtolower($_REQUEST['form']), self::$ignoreForms)) || (isset($_REQUEST['page']) && in_array(strtolower($_REQUEST['page']), self::$ignorePages))) return;
		
		// if the modul activate and the user must agree the rules after a change, and the user is not a guest.
		if (REGISTER_RULE_AGREE_CHANGE && $session->getUser()->userID) {
			// select all packageids of the packages where the user is agree with the rules.
			$packageIDs = $session->getVar('package_agrees');
			
			// if the packageid array null or the current package is not in the id, must check the agreement.
			if (is_null($packageIDs) || !in_array(PACKAGE_ID, $packageIDs)) {
				// we check the agreement, is the user agree with the rules, we put the package id in to the array and leave the event.
				if (Ruleset::isUserAgree($session->getUser()->userID, PACKAGE_ID)) {
					if (is_null($packageIDs) || !is_array($packageIDs)) $packageIDs = array(PACKAGE_ID);
					else $packageIDs[] = PACKAGE_ID;
					$session->register('package_agrees', $packageIDs);
					return;
				}
				HeaderUtil::redirect(FileUtil::addTrailingSlash(FileUtil::unifyDirSeperator(dirname(UserUtil::getRequestURI()))).'index.php?form=RulesAgree'.SID_ARG_2ND_NOT_ENCODED, false);
			}
		}
	}
}
?>